diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/category-template.php ./wordpress-3.4/wp-includes/category-template.php
*** ./wordpress-3.3.2/wp-includes/category-template.php	2011-11-14 11:24:14.000000000 -0600
--- ./wordpress-3.4/wp-includes/category-template.php	2012-05-01 17:09:55.000000000 -0500
***************
*** 56,62 ****
  	}
  
  	if ( $link )
! 		$chain .= '<a href="' . get_category_link( $parent->term_id ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $parent->name ) ) . '">'.$name.'</a>' . $separator;
  	else
  		$chain .= $name.$separator;
  	return $chain;
--- 56,62 ----
  	}
  
  	if ( $link )
! 		$chain .= '<a href="' . esc_url( get_category_link( $parent->term_id ) ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $parent->name ) ) . '">'.$name.'</a>' . $separator;
  	else
  		$chain .= $name.$separator;
  	return $chain;
***************
*** 153,162 ****
   */
  function get_the_category_list( $separator = '', $parents='', $post_id = false ) {
  	global $wp_rewrite;
! 	$categories = get_the_category( $post_id );
! 	if ( !is_object_in_taxonomy( get_post_type( $post_id ), 'category' ) )
  		return apply_filters( 'the_category', '', $separator, $parents );
  
  	if ( empty( $categories ) )
  		return apply_filters( 'the_category', __( 'Uncategorized' ), $separator, $parents );
  
--- 153,162 ----
   */
  function get_the_category_list( $separator = '', $parents='', $post_id = false ) {
  	global $wp_rewrite;
! 	if ( ! is_object_in_taxonomy( get_post_type( $post_id ), 'category' ) )
  		return apply_filters( 'the_category', '', $separator, $parents );
  
+ 	$categories = get_the_category( $post_id );
  	if ( empty( $categories ) )
  		return apply_filters( 'the_category', __( 'Uncategorized' ), $separator, $parents );
  
***************
*** 171,187 ****
  				case 'multiple':
  					if ( $category->parent )
  						$thelist .= get_category_parents( $category->parent, true, $separator );
! 					$thelist .= '<a href="' . get_category_link( $category->term_id ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>' . $category->name.'</a></li>';
  					break;
  				case 'single':
! 					$thelist .= '<a href="' . get_category_link( $category->term_id ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>';
  					if ( $category->parent )
  						$thelist .= get_category_parents( $category->parent, false, $separator );
  					$thelist .= $category->name.'</a></li>';
  					break;
  				case '':
  				default:
! 					$thelist .= '<a href="' . get_category_link( $category->term_id ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>' . $category->name.'</a></li>';
  			}
  		}
  		$thelist .= '</ul>';
--- 171,187 ----
  				case 'multiple':
  					if ( $category->parent )
  						$thelist .= get_category_parents( $category->parent, true, $separator );
! 					$thelist .= '<a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>' . $category->name.'</a></li>';
  					break;
  				case 'single':
! 					$thelist .= '<a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>';
  					if ( $category->parent )
  						$thelist .= get_category_parents( $category->parent, false, $separator );
  					$thelist .= $category->name.'</a></li>';
  					break;
  				case '':
  				default:
! 					$thelist .= '<a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>' . $category->name.'</a></li>';
  			}
  		}
  		$thelist .= '</ul>';
***************
*** 194,210 ****
  				case 'multiple':
  					if ( $category->parent )
  						$thelist .= get_category_parents( $category->parent, true, $separator );
! 					$thelist .= '<a href="' . get_category_link( $category->term_id ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>' . $category->name.'</a>';
  					break;
  				case 'single':
! 					$thelist .= '<a href="' . get_category_link( $category->term_id ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>';
  					if ( $category->parent )
  						$thelist .= get_category_parents( $category->parent, false, $separator );
  					$thelist .= "$category->name</a>";
  					break;
  				case '':
  				default:
! 					$thelist .= '<a href="' . get_category_link( $category->term_id ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>' . $category->name.'</a>';
  			}
  			++$i;
  		}
--- 194,210 ----
  				case 'multiple':
  					if ( $category->parent )
  						$thelist .= get_category_parents( $category->parent, true, $separator );
! 					$thelist .= '<a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>' . $category->name.'</a>';
  					break;
  				case 'single':
! 					$thelist .= '<a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>';
  					if ( $category->parent )
  						$thelist .= get_category_parents( $category->parent, false, $separator );
  					$thelist .= "$category->name</a>";
  					break;
  				case '':
  				default:
! 					$thelist .= '<a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $category->name ) ) . '" ' . $rel . '>' . $category->name.'</a>';
  			}
  			++$i;
  		}
***************
*** 228,234 ****
   * @since 1.2.0
   *
   * @param int|string|array $category Category ID, name or slug, or array of said.
!  * @param int|object $_post Optional. Post to check instead of the current post. (since 2.7.0)
   * @return bool True if the current post is in any of the given categories.
   */
  function in_category( $category, $post = null ) {
--- 227,233 ----
   * @since 1.2.0
   *
   * @param int|string|array $category Category ID, name or slug, or array of said.
!  * @param int|object $post Optional. Post to check instead of the current post. (since 2.7.0)
   * @return bool True if the current post is in any of the given categories.
   */
  function in_category( $category, $post = null ) {
***************
*** 272,278 ****
   *     'orderby' (string) default is 'ID' - What column to use for ordering the
   * categories.
   *     'order' (string) default is 'ASC' - What direction to order categories.
-  *     'show_last_update' (bool|int) default is 0 - See {@link get_categories()}
   *     'show_count' (bool|int) default is 0 - Whether to show how many posts are
   * in the category.
   *     'hide_empty' (bool|int) default is 1 - Whether to hide categories that
--- 271,276 ----
***************
*** 302,308 ****
  	$defaults = array(
  		'show_option_all' => '', 'show_option_none' => '',
  		'orderby' => 'id', 'order' => 'ASC',
! 		'show_last_update' => 0, 'show_count' => 0,
  		'hide_empty' => 1, 'child_of' => 0,
  		'exclude' => '', 'echo' => 1,
  		'selected' => 0, 'hierarchical' => 0,
--- 300,306 ----
  	$defaults = array(
  		'show_option_all' => '', 'show_option_none' => '',
  		'orderby' => 'id', 'order' => 'ASC',
! 		'show_count' => 0,
  		'hide_empty' => 1, 'child_of' => 0,
  		'exclude' => '', 'echo' => 1,
  		'selected' => 0, 'hierarchical' => 0,
***************
*** 326,332 ****
  		$r['pad_counts'] = true;
  	}
  
- 	$r['include_last_update_time'] = $r['show_last_update'];
  	extract( $r );
  
  	$tab_index_attribute = '';
--- 324,329 ----
***************
*** 389,396 ****
   *     'orderby' (string) default is 'ID' - What column to use for ordering the
   * categories.
   *     'order' (string) default is 'ASC' - What direction to order categories.
-  *     'show_last_update' (bool|int) default is 0 - See {@link
-  * walk_category_dropdown_tree()}
   *     'show_count' (bool|int) default is 0 - Whether to show how many posts are
   * in the category.
   *     'hide_empty' (bool|int) default is 1 - Whether to hide categories that
--- 386,391 ----
***************
*** 418,424 ****
  	$defaults = array(
  		'show_option_all' => '', 'show_option_none' => __('No categories'),
  		'orderby' => 'name', 'order' => 'ASC',
! 		'show_last_update' => 0, 'style' => 'list',
  		'show_count' => 0, 'hide_empty' => 1,
  		'use_desc_for_title' => 1, 'child_of' => 0,
  		'feed' => '', 'feed_type' => '',
--- 413,419 ----
  	$defaults = array(
  		'show_option_all' => '', 'show_option_none' => __('No categories'),
  		'orderby' => 'name', 'order' => 'ASC',
! 		'style' => 'list',
  		'show_count' => 0, 'hide_empty' => 1,
  		'use_desc_for_title' => 1, 'child_of' => 0,
  		'feed' => '', 'feed_type' => '',
***************
*** 434,442 ****
  	if ( !isset( $r['pad_counts'] ) && $r['show_count'] && $r['hierarchical'] )
  		$r['pad_counts'] = true;
  
- 	if ( isset( $r['show_date'] ) )
- 		$r['include_last_update_time'] = $r['show_date'];
- 
  	if ( true == $r['hierarchical'] ) {
  		$r['exclude_tree'] = $r['exclude'];
  		$r['exclude'] = '';
--- 429,434 ----
***************
*** 614,620 ****
   * @return string
   */
  function wp_generate_tag_cloud( $tags, $args = '' ) {
- 	global $wp_rewrite;
  	$defaults = array(
  		'smallest' => 8, 'largest' => 22, 'unit' => 'pt', 'number' => 0,
  		'format' => 'flat', 'separator' => "\n", 'orderby' => 'name', 'order' => 'ASC',
--- 605,610 ----
***************
*** 682,688 ****
  		$tag_id = isset($tags[ $key ]->id) ? $tags[ $key ]->id : $key;
  		$tag_name = $tags[ $key ]->name;
  		$a[] = "<a href='$tag_link' class='tag-link-$tag_id' title='" . esc_attr( call_user_func( $topic_count_text_callback, $real_count ) ) . "' style='font-size: " .
! 			( $smallest + ( ( $count - $min_count ) * $font_step ) )
  			. "$unit;'>$tag_name</a>";
  	}
  
--- 672,678 ----
  		$tag_id = isset($tags[ $key ]->id) ? $tags[ $key ]->id : $key;
  		$tag_name = $tags[ $key ]->name;
  		$a[] = "<a href='$tag_link' class='tag-link-$tag_id' title='" . esc_attr( call_user_func( $topic_count_text_callback, $real_count ) ) . "' style='font-size: " .
! 			str_replace( ',', '.', ( $smallest + ( ( $count - $min_count ) * $font_step ) ) )
  			. "$unit;'>$tag_name</a>";
  	}
  
***************
*** 797,803 ****
  	 * @param int $depth Depth of category. Used for tab indentation.
  	 * @param array $args Will only append content if style argument value is 'list'.
  	 */
! 	function start_lvl(&$output, $depth, $args) {
  		if ( 'list' != $args['style'] )
  			return;
  
--- 787,793 ----
  	 * @param int $depth Depth of category. Used for tab indentation.
  	 * @param array $args Will only append content if style argument value is 'list'.
  	 */
! 	function start_lvl( &$output, $depth = 0, $args = array() ) {
  		if ( 'list' != $args['style'] )
  			return;
  
***************
*** 813,819 ****
  	 * @param int $depth Depth of category. Used for tab indentation.
  	 * @param array $args Will only append content if style argument value is 'list'.
  	 */
! 	function end_lvl(&$output, $depth, $args) {
  		if ( 'list' != $args['style'] )
  			return;
  
--- 803,809 ----
  	 * @param int $depth Depth of category. Used for tab indentation.
  	 * @param array $args Will only append content if style argument value is 'list'.
  	 */
! 	function end_lvl( &$output, $depth = 0, $args = array() ) {
  		if ( 'list' != $args['style'] )
  			return;
  
***************
*** 830,841 ****
  	 * @param int $depth Depth of category in reference to parents.
  	 * @param array $args
  	 */
! 	function start_el(&$output, $category, $depth, $args) {
  		extract($args);
  
  		$cat_name = esc_attr( $category->name );
  		$cat_name = apply_filters( 'list_cats', $cat_name, $category );
! 		$link = '<a href="' . esc_attr( get_term_link($category) ) . '" ';
  		if ( $use_desc_for_title == 0 || empty($category->description) )
  			$link .= 'title="' . esc_attr( sprintf(__( 'View all posts filed under %s' ), $cat_name) ) . '"';
  		else
--- 820,831 ----
  	 * @param int $depth Depth of category in reference to parents.
  	 * @param array $args
  	 */
! 	function start_el( &$output, $category, $depth = 0, $args = array(), $id = 0 ) {
  		extract($args);
  
  		$cat_name = esc_attr( $category->name );
  		$cat_name = apply_filters( 'list_cats', $cat_name, $category );
! 		$link = '<a href="' . esc_url( get_term_link($category) ) . '" ';
  		if ( $use_desc_for_title == 0 || empty($category->description) )
  			$link .= 'title="' . esc_attr( sprintf(__( 'View all posts filed under %s' ), $cat_name) ) . '"';
  		else
***************
*** 849,855 ****
  			if ( empty($feed_image) )
  				$link .= '(';
  
! 			$link .= '<a href="' . get_term_feed_link( $category->term_id, $category->taxonomy, $feed_type ) . '"';
  
  			if ( empty($feed) ) {
  				$alt = ' alt="' . sprintf(__( 'Feed for all posts filed under %s' ), $cat_name ) . '"';
--- 839,845 ----
  			if ( empty($feed_image) )
  				$link .= '(';
  
! 			$link .= '<a href="' . esc_url( get_term_feed_link( $category->term_id, $category->taxonomy, $feed_type ) ) . '"';
  
  			if ( empty($feed) ) {
  				$alt = ' alt="' . sprintf(__( 'Feed for all posts filed under %s' ), $cat_name ) . '"';
***************
*** 876,884 ****
  		if ( !empty($show_count) )
  			$link .= ' (' . intval($category->count) . ')';
  
- 		if ( !empty($show_date) )
- 			$link .= ' ' . gmdate('Y-m-d', $category->last_update_timestamp);
- 
  		if ( 'list' == $args['style'] ) {
  			$output .= "\t<li";
  			$class = 'cat-item cat-item-' . $category->term_id;
--- 866,871 ----
***************
*** 905,911 ****
  	 * @param int $depth Depth of category. Not used.
  	 * @param array $args Only uses 'list' for whether should append to output.
  	 */
! 	function end_el(&$output, $page, $depth, $args) {
  		if ( 'list' != $args['style'] )
  			return;
  
--- 892,898 ----
  	 * @param int $depth Depth of category. Not used.
  	 * @param array $args Only uses 'list' for whether should append to output.
  	 */
! 	function end_el( &$output, $page, $depth = 0, $args = array() ) {
  		if ( 'list' != $args['style'] )
  			return;
  
***************
*** 944,952 ****
  	 * @param string $output Passed by reference. Used to append additional content.
  	 * @param object $category Category data object.
  	 * @param int $depth Depth of category. Used for padding.
! 	 * @param array $args Uses 'selected', 'show_count', and 'show_last_update' keys, if they exist.
  	 */
! 	function start_el(&$output, $category, $depth, $args) {
  		$pad = str_repeat('&nbsp;', $depth * 3);
  
  		$cat_name = apply_filters('list_cats', $category->name, $category);
--- 931,939 ----
  	 * @param string $output Passed by reference. Used to append additional content.
  	 * @param object $category Category data object.
  	 * @param int $depth Depth of category. Used for padding.
! 	 * @param array $args Uses 'selected' and 'show_count' keys, if they exist.
  	 */
! 	function start_el( &$output, $category, $depth, $args, $id = 0 ) {
  		$pad = str_repeat('&nbsp;', $depth * 3);
  
  		$cat_name = apply_filters('list_cats', $category->name, $category);
***************
*** 957,966 ****
  		$output .= $pad.$cat_name;
  		if ( $args['show_count'] )
  			$output .= '&nbsp;&nbsp;('. $category->count .')';
- 		if ( $args['show_last_update'] ) {
- 			$format = 'Y-m-d';
- 			$output .= '&nbsp;&nbsp;' . gmdate($format, $category->last_update_timestamp);
- 		}
  		$output .= "</option>\n";
  	}
  }
--- 944,949 ----
***************
*** 1012,1021 ****
   * @param string $before Optional. Before tags.
   * @param string $sep Optional. Between tags.
   * @param string $after Optional. After tags.
   * @return string
   */
! function get_the_tag_list( $before = '', $sep = '', $after = '' ) {
! 	return apply_filters( 'the_tags', get_the_term_list( 0, 'post_tag', $before, $sep, $after ), $before, $sep, $after);
  }
  
  /**
--- 995,1005 ----
   * @param string $before Optional. Before tags.
   * @param string $sep Optional. Between tags.
   * @param string $after Optional. After tags.
+  * @param int $id Optional. Post ID. Defaults to the current post.
   * @return string
   */
! function get_the_tag_list( $before = '', $sep = '', $after = '', $id = 0 ) {
! 	return apply_filters( 'the_tags', get_the_term_list( $id, 'post_tag', $before, $sep, $after ), $before, $sep, $after, $id );
  }
  
  /**
***************
*** 1052,1057 ****
--- 1036,1042 ----
   * @since 2.8
   *
   * @param int $term Optional. Term ID. Will use global term ID by default.
+  * @param string $taxonomy Optional taxonomy name. Defaults to 'post_tag'.
   * @return string Term description, available.
   */
  function term_description( $term = 0, $taxonomy = 'post_tag' ) {
***************
*** 1069,1085 ****
   *
   * @since 2.5.0
   *
!  * @param int $id Post ID. Is not optional.
   * @param string $taxonomy Taxonomy name.
   * @return array|bool False on failure. Array of term objects on success.
   */
! function get_the_terms( $id = 0, $taxonomy ) {
  	global $post;
  
   	$id = (int) $id;
  
  	if ( !$id ) {
! 		if ( !$post->ID )
  			return false;
  		else
  			$id = (int) $post->ID;
--- 1054,1070 ----
   *
   * @since 2.5.0
   *
!  * @param int $id Post ID.
   * @param string $taxonomy Taxonomy name.
   * @return array|bool False on failure. Array of term objects on success.
   */
! function get_the_terms( $id, $taxonomy ) {
  	global $post;
  
   	$id = (int) $id;
  
  	if ( !$id ) {
! 		if ( empty( $post->ID ) )
  			return false;
  		else
  			$id = (int) $post->ID;
***************
*** 1111,1117 ****
   * @param string $after Optional. After list.
   * @return string
   */
! function get_the_term_list( $id = 0, $taxonomy, $before = '', $sep = '', $after = '' ) {
  	$terms = get_the_terms( $id, $taxonomy );
  
  	if ( is_wp_error( $terms ) )
--- 1096,1102 ----
   * @param string $after Optional. After list.
   * @return string
   */
! function get_the_term_list( $id, $taxonomy, $before = '', $sep = '', $after = '' ) {
  	$terms = get_the_terms( $id, $taxonomy );
  
  	if ( is_wp_error( $terms ) )
***************
*** 1124,1130 ****
  		$link = get_term_link( $term, $taxonomy );
  		if ( is_wp_error( $link ) )
  			return $link;
! 		$term_links[] = '<a href="' . $link . '" rel="tag">' . $term->name . '</a>';
  	}
  
  	$term_links = apply_filters( "term_links-$taxonomy", $term_links );
--- 1109,1115 ----
  		$link = get_term_link( $term, $taxonomy );
  		if ( is_wp_error( $link ) )
  			return $link;
! 		$term_links[] = '<a href="' . esc_url( $link ) . '" rel="tag">' . $term->name . '</a>';
  	}
  
  	$term_links = apply_filters( "term_links-$taxonomy", $term_links );
***************
*** 1144,1150 ****
   * @param string $after Optional. After list.
   * @return null|bool False on WordPress error. Returns null when displaying.
   */
! function the_terms( $id = 0, $taxonomy, $before = '', $sep = ', ', $after = '' ) {
  	$term_list = get_the_term_list( $id, $taxonomy, $before, $sep, $after );
  
  	if ( is_wp_error( $term_list ) )
--- 1129,1135 ----
   * @param string $after Optional. After list.
   * @return null|bool False on WordPress error. Returns null when displaying.
   */
! function the_terms( $id, $taxonomy, $before = '', $sep = ', ', $after = '' ) {
  	$term_list = get_the_term_list( $id, $taxonomy, $before, $sep, $after );
  
  	if ( is_wp_error( $term_list ) )
***************
*** 1159,1165 ****
   *
   * @since 3.1.0
   *
!  * @param string|int|array $tag Optional. The category name/term_id/slug or array of them to check for.
   * @param int|object $post Optional. Post to check instead of the current post.
   * @return bool True if the current post has any of the given categories (or any category, if no category specified).
   */
--- 1143,1149 ----
   *
   * @since 3.1.0
   *
!  * @param string|int|array $category Optional. The category name/term_id/slug or array of them to check for.
   * @param int|object $post Optional. Post to check instead of the current post.
   * @return bool True if the current post has any of the given categories (or any category, if no category specified).
   */
***************
*** 1214,1218 ****
  
  	return $r;
  }
- 
- ?>
--- 1198,1200 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-http.php ./wordpress-3.4/wp-includes/class-http.php
*** ./wordpress-3.3.2/wp-includes/class-http.php	2011-10-31 14:38:46.000000000 -0500
--- ./wordpress-3.4/wp-includes/class-http.php	2012-05-10 16:32:02.000000000 -0500
***************
*** 201,207 ****
  	 * @param array $args Request arguments
  	 * @param string $url URL to Request
  	 *
! 	 * @return string|false Class name for the first transport that claims to support the request.  False if no transport claims to support the request.
  	 */
  	public function _get_first_available_transport( $args, $url = null ) {
  		$request_order = array( 'curl', 'streams', 'fsockopen' );
--- 200,206 ----
  	 * @param array $args Request arguments
  	 * @param string $url URL to Request
  	 *
! 	 * @return string|false Class name for the first transport that claims to support the request. False if no transport claims to support the request.
  	 */
  	public function _get_first_available_transport( $args, $url = null ) {
  		$request_order = array( 'curl', 'streams', 'fsockopen' );
***************
*** 535,542 ****
--- 534,588 ----
  		else
  			return !in_array( $check['host'], $accessible_hosts ); //Inverse logic, If its in the array, then we can't access it.
  
+ 	}
  
+ 	static function make_absolute_url( $maybe_relative_path, $url ) {
+ 		if ( empty( $url ) )
+ 			return $maybe_relative_path;
+ 
+ 		// Check for a scheme
+ 		if ( false !== strpos( $maybe_relative_path, '://' ) )
+ 			return $maybe_relative_path;
+ 
+ 		if ( ! $url_parts = @parse_url( $url ) )
+ 			return $maybe_relative_path;
+ 
+ 		if ( ! $relative_url_parts = @parse_url( $maybe_relative_path ) )
+ 			return $maybe_relative_path;
+ 
+ 		$absolute_path = $url_parts['scheme'] . '://' . $url_parts['host'];
+ 		if ( isset( $url_parts['port'] ) )
+ 			$absolute_path .= ':' . $url_parts['port'];
+ 
+ 		// Start off with the Absolute URL path
+ 		$path = ! empty( $url_parts['path'] ) ? $url_parts['path'] : '/';
+ 
+ 		// If the it's a root-relative path, then great
+ 		if ( ! empty( $relative_url_parts['path'] ) && '/' == $relative_url_parts['path'][0] ) {
+ 			$path = $relative_url_parts['path'];
+ 
+ 		// Else it's a relative path
+ 		} elseif ( ! empty( $relative_url_parts['path'] ) ) {
+ 			// Strip off any file components from the absolute path
+ 			$path = substr( $path, 0, strrpos( $path, '/' ) + 1 );
+ 
+ 			// Build the new path
+ 			$path .= $relative_url_parts['path'];
+ 
+ 			// Strip all /path/../ out of the path
+ 			while ( strpos( $path, '../' ) > 1 ) {
+ 				$path = preg_replace( '![^/]+/\.\./!', '', $path );
+ 			}
  
+ 			// Strip any final leading ../ from the path
+ 			$path = preg_replace( '!^/(\.\./)+!', '', $path );
+ 		}
+ 
+ 		// Add the Query string
+ 		if ( ! empty( $relative_url_parts['query'] ) )
+ 			$path .= '?' . $relative_url_parts['query'];
+ 
+ 		return $absolute_path . '/' . ltrim( $path, '/' );
  	}
  }
  
***************
*** 733,739 ****
  		// If location is found, then assume redirect and redirect to location.
  		if ( isset($arrHeaders['headers']['location']) && 0 !== $r['_redirection'] ) {
  			if ( $r['redirection']-- > 0 ) {
! 				return $this->request($arrHeaders['headers']['location'], $r);
  			} else {
  				return new WP_Error('http_request_failed', __('Too many redirects.'));
  			}
--- 779,785 ----
  		// If location is found, then assume redirect and redirect to location.
  		if ( isset($arrHeaders['headers']['location']) && 0 !== $r['_redirection'] ) {
  			if ( $r['redirection']-- > 0 ) {
! 				return $this->request( WP_HTTP::make_absolute_url( $arrHeaders['headers']['location'], $url ), $r);
  			} else {
  				return new WP_Error('http_request_failed', __('Too many redirects.'));
  			}
***************
*** 1023,1037 ****
  			}
  		}
  
! 		$is_local = isset($args['local']) && $args['local'];
! 		$ssl_verify = isset($args['sslverify']) && $args['sslverify'];
  		if ( $is_local )
  			$ssl_verify = apply_filters('https_local_ssl_verify', $ssl_verify);
  		elseif ( ! $is_local )
  			$ssl_verify = apply_filters('https_ssl_verify', $ssl_verify);
  
! 
! 		// CURLOPT_TIMEOUT and CURLOPT_CONNECTTIMEOUT expect integers.  Have to use ceil since
  		// a value of 0 will allow an unlimited timeout.
  		$timeout = (int) ceil( $r['timeout'] );
  		curl_setopt( $handle, CURLOPT_CONNECTTIMEOUT, $timeout );
--- 1069,1082 ----
  			}
  		}
  
! 		$is_local = isset($r['local']) && $r['local'];
! 		$ssl_verify = isset($r['sslverify']) && $r['sslverify'];
  		if ( $is_local )
  			$ssl_verify = apply_filters('https_local_ssl_verify', $ssl_verify);
  		elseif ( ! $is_local )
  			$ssl_verify = apply_filters('https_ssl_verify', $ssl_verify);
  
! 		// CURLOPT_TIMEOUT and CURLOPT_CONNECTTIMEOUT expect integers. Have to use ceil since
  		// a value of 0 will allow an unlimited timeout.
  		$timeout = (int) ceil( $r['timeout'] );
  		curl_setopt( $handle, CURLOPT_CONNECTTIMEOUT, $timeout );
***************
*** 1042,1048 ****
  		curl_setopt( $handle, CURLOPT_SSL_VERIFYHOST, ( $ssl_verify === true ) ? 2 : false );
  		curl_setopt( $handle, CURLOPT_SSL_VERIFYPEER, $ssl_verify );
  		curl_setopt( $handle, CURLOPT_USERAGENT, $r['user-agent'] );
! 		curl_setopt( $handle, CURLOPT_MAXREDIRS, $r['redirection'] );
  
  		switch ( $r['method'] ) {
  			case 'HEAD':
--- 1087,1095 ----
  		curl_setopt( $handle, CURLOPT_SSL_VERIFYHOST, ( $ssl_verify === true ) ? 2 : false );
  		curl_setopt( $handle, CURLOPT_SSL_VERIFYPEER, $ssl_verify );
  		curl_setopt( $handle, CURLOPT_USERAGENT, $r['user-agent'] );
! 		// The option doesn't work with safe mode or when open_basedir is set, and there's a
! 		// bug #17490 with redirected POST requests, so handle redirections outside Curl.
! 		curl_setopt( $handle, CURLOPT_FOLLOWLOCATION, false );
  
  		switch ( $r['method'] ) {
  			case 'HEAD':
***************
*** 1056,1061 ****
--- 1103,1113 ----
  				curl_setopt( $handle, CURLOPT_CUSTOMREQUEST, 'PUT' );
  				curl_setopt( $handle, CURLOPT_POSTFIELDS, $r['body'] );
  				break;
+ 			default:
+ 				curl_setopt( $handle, CURLOPT_CUSTOMREQUEST, $r['method'] );
+ 				if ( ! empty( $r['body'] ) )
+ 					curl_setopt( $handle, CURLOPT_POSTFIELDS, $r['body'] );
+ 				break;
  		}
  
  		if ( true === $r['blocking'] )
***************
*** 1074,1083 ****
  			curl_setopt( $handle, CURLOPT_FILE, $stream_handle );
  		}
  
- 		// The option doesn't work with safe mode or when open_basedir is set.
- 		if ( !ini_get('safe_mode') && !ini_get('open_basedir') && 0 !== $r['_redirection'] )
- 			curl_setopt( $handle, CURLOPT_FOLLOWLOCATION, true );
- 
  		if ( !empty( $r['headers'] ) ) {
  			// cURL expects full header strings in each element
  			$headers = array();
--- 1126,1131 ----
***************
*** 1110,1121 ****
  		if ( strlen($theResponse) > 0 && ! is_bool( $theResponse ) ) // is_bool: when using $args['stream'], curl_exec will return (bool)true
  			$theBody = $theResponse;
  
! 		// If no response, and It's not a HEAD request with valid headers returned
! 		if ( 0 == strlen($theResponse) && ('HEAD' != $args['method'] || empty($this->headers)) ) {
! 			if ( $curl_error = curl_error($handle) )
! 				return new WP_Error('http_request_failed', $curl_error);
! 			if ( in_array( curl_getinfo( $handle, CURLINFO_HTTP_CODE ), array(301, 302) ) )
! 				return new WP_Error('http_request_failed', __('Too many redirects.'));
  		}
  
  		$this->headers = '';
--- 1158,1169 ----
  		if ( strlen($theResponse) > 0 && ! is_bool( $theResponse ) ) // is_bool: when using $args['stream'], curl_exec will return (bool)true
  			$theBody = $theResponse;
  
! 		// If no response
! 		if ( 0 == strlen( $theResponse ) && empty( $theHeaders['headers'] ) ) {
! 			if ( $curl_error = curl_error( $handle ) )
! 				return new WP_Error( 'http_request_failed', $curl_error );
! 			if ( in_array( curl_getinfo( $handle, CURLINFO_HTTP_CODE ), array( 301, 302 ) ) )
! 				return new WP_Error( 'http_request_failed', __( 'Too many redirects.' ) );
  		}
  
  		$this->headers = '';
***************
*** 1130,1138 ****
  			fclose( $stream_handle );
  
  		// See #11305 - When running under safe mode, redirection is disabled above. Handle it manually.
! 		if ( ! empty( $theHeaders['headers']['location'] ) && ( ini_get( 'safe_mode' ) || ini_get( 'open_basedir' ) ) && 0 !== $r['_redirection'] ) {
  			if ( $r['redirection']-- > 0 ) {
! 				return $this->request( $theHeaders['headers']['location'], $r );
  			} else {
  				return new WP_Error( 'http_request_failed', __( 'Too many redirects.' ) );
  			}
--- 1178,1186 ----
  			fclose( $stream_handle );
  
  		// See #11305 - When running under safe mode, redirection is disabled above. Handle it manually.
! 		if ( ! empty( $theHeaders['headers']['location'] ) && 0 !== $r['_redirection'] ) { // _redirection: The requested number of redirections
  			if ( $r['redirection']-- > 0 ) {
! 				return $this->request( WP_HTTP::make_absolute_url( $theHeaders['headers']['location'], $url ), $r );
  			} else {
  				return new WP_Error( 'http_request_failed', __( 'Too many redirects.' ) );
  			}
***************
*** 1494,1500 ****
  	 * @since 2.8.0
  	 *
  	 * @param string $url URL you intend to send this cookie to
! 	 * @return boolean TRUE if allowed, FALSE otherwise.
  	 */
  	function test( $url ) {
  		// Expires - if expired then nothing else matters
--- 1542,1548 ----
  	 * @since 2.8.0
  	 *
  	 * @param string $url URL you intend to send this cookie to
! 	 * @return boolean true if allowed, false otherwise.
  	 */
  	function test( $url ) {
  		// Expires - if expired then nothing else matters
***************
*** 1541,1547 ****
  		if ( empty( $this->name ) || empty( $this->value ) )
  			return '';
  
! 		return $this->name . '=' . urlencode( $this->value );
  	}
  
  	/**
--- 1589,1595 ----
  		if ( empty( $this->name ) || empty( $this->value ) )
  			return '';
  
! 		return $this->name . '=' . apply_filters( 'wp_http_cookie_value', $this->value, $this->name );
  	}
  
  	/**
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-IXR.php ./wordpress-3.4/wp-includes/class-IXR.php
*** ./wordpress-3.3.2/wp-includes/class-IXR.php	2010-12-08 13:27:49.000000000 -0600
--- ./wordpress-3.4/wp-includes/class-IXR.php	2012-01-08 11:01:11.000000000 -0600
***************
*** 1061,1065 ****
          return parent::query('system.multicall', $this->calls);
      }
  }
- 
- ?>
--- 1061,1063 ----
